translate([0,0,5])	
	rotate([0,180,0])
		center();

module center()
{
	long=150;
	side=25;
	hollow=10;

	cableholer=5;

	bolthole=2;

	extra=100;
	hole=1.61;
	margin=4;


	difference()
	{
		//mount
		cube([53,53,5]);

		translate([hole/2+margin,hole/2+margin,0])
			cylinder(5,hole,hole);

		translate([53 -hole/2-margin,hole/2+margin,0])
			cylinder(5,hole,hole);

		translate([hole/2+margin,53 -hole/2-margin,0])
			cylinder(5,hole,hole);

		translate([53 -hole/2-margin,53 -hole/2-margin,0])
			cylinder(5,hole,hole);
	}

	//sides

	sside=53-hole*2-margin*4;

	translate([-extra/4,margin*2+hole,0])
		cube([extra,sside,5]);

	translate([margin*2+hole,-extra/4,0])
		cube([sside,extra,5]);

	//armholders

	spare=(extra-70)/2;

	armholder();

	translate([extra/2,53,0])
		rotate([0,0,180])
			armholder();

	translate([53,0,0])
		rotate([0,0,90])
			armholder();

	translate([0,extra/2,0])
		rotate([0,0,270])
			armholder();

	hook=side/2-cableholer+3;
	
	module armholder()
	{
		module a()
		{
			difference()
			{
				union()
				{
					hull()
					{
						translate([-extra/4,53/2-sside/2,-side/2])
							cube([spare,sside,side/2]);

						translate([-extra/4,53/2-cableholer,-side/2-side/4-1])
							cube([0.001,cableholer*2,side-1]);
					}

					translate([-extra/4-hook, 53/2-cableholer,-side/2-side/4-1])
						cube([hook,cableholer*2,side]);
						
					translate([-extra/4-hook, 53/2-cableholer,-side/2-side/4-1])
						cube([hook,cableholer*2,side]);

				}
				
				// ATTENTION: This is what caused the manifold problem
				translate([-extra/4-hook/2, 53/2 + cableholer + 1,
					-side/2-side/4-1 +side/2 +cableholer +(side-cableholer*2)/4])
						rotate([90,0,0])
							cylinder(cableholer*2+2,bolthole,bolthole);

				// ATTENTION: This is what caused the manifold problem
				translate([-extra/4-hook/2, 53/2 + cableholer + 1,
					-side/2-side/4-1 + side/2 - cableholer -(side-cableholer*2)/4])
						rotate([90,0,0])
							cylinder(cableholer*2+2,bolthole,bolthole);
			}
		}

		difference() {
			a();

			translate([-50,53/2,(-side/2-side/4-1)/2+cableholer/2])
				rotate([0,90,0])
					// ATTENTION: This is what caused the manifold problem
					cylinder(long, cableholer-.001, cableholer-.001);
		}
	}

	//battery holder

	//GPS holder

	gx=30;
	gy=26;
	gz=6.8;
	gbolt=0.5;
	gm=0.5;

	translate([10,5,gz+10.5])
		rotate([0,0,-45])
			gps();

	module gps()
	{
		difference()
		{
			translate([long-extra-sside+gx-hook/2,53/2-(gy+margin)/2,-side/2-side/4-1-(gz+margin)/2+2])
				cube([gx+margin,gy+margin,gz+margin]);

			translate([long-extra-sside+gx-hook/2,53/2-gy/2,-side/2-side/4-1-(gz+margin)/2])
				cube([gx,gy,gz]);

			translate([long-extra-sside+gx-hook/2+gm+gbolt,
				53/2-(gy+margin)/2+gbolt+margin/2+gm,-side/2-side/4-1-(gz+margin)/2+2])
					cylinder(margin*4,gbolt,gbolt);

			translate([long-extra-sside+gx-hook/2+gm+gbolt,53/2-(gy+margin)/2-gbolt+margin/2-gm+gy,
				-side/2-side/4-1-(gz+margin)/2+2])
					cylinder(margin*4,gbolt,gbolt);

		}
	}

	//Receiver holder

	rx = 35;
	ry = 52;
	rz=15.3;
	rar=2.5;

	translate([-19,43.5,2])
		rotate([0,0,43])
			receiver();
			
	module receiver()
	{
		difference() {
			translate([0,0,-rz+1])cube([rx+margin,ry+margin/2,rz+margin/2]);
				translate([margin/2,0,-rz+1])
					cube([rx,ry,rz]);

			translate([rx/2+rar+4,ry+margin,+margin/2+1-rar-5])
				rotate([90,0,0])
					cylinder(margin*2,rar,rar);
		}
	}


	//Surrounding circle
	difference()
	{
		translate([extra/4,extra/4,-5.8])
			cylinder(gz+margin,extra/2,extra/2);

		translate([extra/4,extra/4,-5.8])
			cylinder(gz+margin,extra/2-2,extra/2-2);

		translate([-19,43.5,-rz+margin])
			rotate([0,0,43])
				cube([rx+4,ry,rz]);

		translate([47,-15,-10.5])
			rotate([0,0,-45])
				cube([gx+10,gy+3,16]);

		translate([-50,53/2,(-side/2-side/4-1)/2+cableholer/2])
			rotate([0,90,0])
				cylinder(long, cableholer, cableholer);

		translate([53/2,-53,(-side/2-side/4-1)/2+cableholer/2])
			rotate([0,90,90])
				cylinder(long, cableholer, cableholer);
	}

	//Generic holders

	translate([-6,-12.5,-5.8])
		rotate([0,0,135])
			generic();

	translate([72,64,-5.8])
		rotate([0,0,135])
			generic();
			
	module generic()
	{
		difference()
		{
			cube([12,12,gz+margin]);

			translate([(6-bolthole*2)/2+bolthole,6,0])
				cylinder(gz+margin,bolthole,bolthole);

			translate([12-(6-bolthole*2)/2-bolthole,6,0])
				cylinder(gz+margin,bolthole,bolthole);
		}
	}
}
